
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "shared.h"
#include "semaphore.h"

#define TRUE 1
#define FALSE 0

#define KEY_FILE "key_file"


// struttura di definizione dell'area di memoria condivisa
struct SHARED
{
 unsigned int number; // numero sequenziale
 int request_semaphore; // semaforo per segnalazione richiesta dato
 int data_semaphore; // semaforo per segnalazione dato disponibile
};

struct SHARED *shared; // puntatore area di memoria condivisa


int main(int argc, char* argv[])
{
 int key; // chiave per creazione area di memoria condivisa
 unsigned int number;
 
 // generazione chiave per allocazione area di memoria condivisa
 key = ftok(KEY_FILE, '@');
 if (key == -1)
   {
    printf("ftok error\r\n");
    return 0;
   }
 // associazione area memoria condivisa
 shared = (struct SHARED*)shared_memory_alloc_key(sizeof(struct SHARED), key, FALSE);
 if (shared == (struct SHARED*)(-1))
   {
    printf("shared_memory_alloc error\r\n");
    return 0;
   }
 semaphore_wait(shared->data_semaphore);
 number = shared->number;
 semaphore_signal(shared->request_semaphore);
 printf("Number: %u\r\n", number);
 return 1;
}
