
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "shared.h"
#include "semaphore.h"

#define KEY_FILE "key_file"

void new(unsigned char key[16])
{
    int i;
    
    for(i=0; i<16; i++)
        key[i] = rand()%256;
}

#define TRUE 1
#define FALSE 0


// struttura di definizione dell'area di memoria condivisa
struct SHARED
{
 unsigned char key[16]; // dato condiviso
 int mutex_semaphore; // semaforo per accesso mutuamente esclusivo
};

struct SHARED *shared; // puntatore area di memoria condivisa


int main(int argc, char* argv[])
{
 int key; // chiave per creazione area di memoria condivisa

 // generazione chiave per allocazione area di memoria condivisa
 key = ftok(KEY_FILE, '@');
 if (key == -1)
   {
    printf("ftok error\r\n");
    return 0;
   }
 // allocazione area memoria condivisa
 shared = (struct SHARED*)shared_memory_alloc_key(sizeof(struct SHARED), key, TRUE);
 if (shared == (struct SHARED*)(-1))
   {
    printf("shared_memory_alloc error\r\n");
    return 0;
   }
 // inizializzazione semaforo
 shared->mutex_semaphore = semaphore_init(1);
 if (shared->mutex_semaphore == -1)
   {
    printf("semaphore_init error\r\n");
    shared_memory_free(shared);
    return 0;
   }
 // inizializzazione variabile condivise
 new(shared->key);
 // esecuzione ciclo processo generatore
 do
   {
    usleep(1000000); // attesa 1s
    semaphore_wait(shared->mutex_semaphore);
    new(shared->key); // generazione nuova chiave
    semaphore_signal(shared->mutex_semaphore);
   } while (TRUE);
 shared_memory_free(shared); // rimozione area memoria condivisa
 return 1;
}
