
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "shared.h"
#include "semaphore.h"

#define KEY_FILE "key_file"

#define TRUE 1
#define FALSE 0

// struttura di definizione dell'area di memoria condivisa
struct SHARED
{
 unsigned char key[16]; // dato condiviso
 int mutex_semaphore; // semaforo per accesso mutuamente esclusivo
};

int getLastKey(unsigned char lastKey[16])
{
   struct SHARED *shared; // puntatore area di memoria condivisa
   int key; // chiave per creazione area di memoria condivisa

   // generazione chiave per allocazione area di memoria condivisa
   key = ftok(KEY_FILE, '@');
   if (key == -1)
     return -1;
   // associazione area memoria condivisa
   shared = (struct SHARED*)shared_memory_alloc_key(sizeof(struct SHARED), key, FALSE);
   if (shared == (struct SHARED*)(-1))
     return -1;
   semaphore_wait(shared->mutex_semaphore);
   memcpy(lastKey, shared->key, 16);
   semaphore_signal(shared->mutex_semaphore);
   //shared_memory_free(shared);
   return 0;
}




int main(int argc, char* argv[])
{
 unsigned char key[16];
 int i;
 
 do
   {
    usleep(1000000);    
    if (getLastKey(key)>= 0)
    {
     for(i=0; i<16; i++)
         printf("%02X", key[i]);
     printf("\r\n");
    }
    else
        printf("ERROR\r\n");
   } while (TRUE);
 return 1;
}
