
#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>


#include "global.h"
#include "md5.h"
 
int main (int argc, char* argv[])
{
 MD5_CTX context;
 FILE *file;
 unsigned char buffer[16];
 unsigned char fingerprint[16];
 int i, n;
 int pid, status;
 int p[2]; // vettore per descrittori estremita' pipe
 
 if (argc != 2)
   {
    printf("Uso: %s file\r\n", argv[0]);
    return 0;
   }
 // creazione pipe
 if (pipe(p) < 0)
   {
    printf("Errore creazione pipe\r\n");
    return 0;
   }
 // fork processo figlio
 pid = fork();
 if (pid < 0)
   {
    printf("Errore invocazione fork\r\n");
    // chiusura estremita' pipe
    close(p[0]);
    close(p[1]);
    return 0;
   }
 if (pid > 0)
   {
    // processo padre
    close(p[0]); // chiusura uscita pipe
    // apertura in lettura file
    file = fopen(argv[1], "rb");
    if (file == NULL)
      {
       printf("Errore apertura file \"%s\"\r\n",argv[1]);
       close(p[1]); // chiusura entrata pipe
       wait(&status); // attesa terminazione processo figlio
       return 0;
      }
    // lettura da file di blocchi di dati di 16 byte
    // e inserimento nella pipe
    while ((n = fread(buffer, 1, 16, file)) > 0)
         {
          write(p[1], buffer, n);
         }
    fclose(file); // chiusura file
    close(p[1]); // chiusura entrata pipe
    wait(&status); // attesa terminazione processo figlio
    return 1; // terminazione processo padre
   }
 else
     {
      // processo figlio
      close(p[1]); // chiusura entrata pipe
      // inizializzazione MD5
      MD5Init(&context);
      // estrazione dalla pipe dei dati a blocchi di 16 byte
      // e aggiornamento MD5
      while ((n = read(p[0], buffer, 16)) > 0)
           {
            MD5Update(&context, buffer, n);
           }
      close(p[0]); // chiusura uscita pipe
      // visualizzazione in esadecimale del fingerprint
      MD5Final(fingerprint, &context);
      for (i=0; i<16; i++)
         {
          printf("%02X", fingerprint[i]);
         }
      printf("\r\n");
      return 1; // terminazione processo figlio
     }
}

