
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

#include "global.h"
#include "md5.h"


int main (int argc, char* argv[])
{
 MD5_CTX context;
 int fifo;
 unsigned char buffer[16], fingerprint[16];
 int i, n;
 // apertura in lettura della FIFO
 // (attesa connessione processo produttore)
 fifo = open("./my_fifo", O_RDONLY);
 if (fifo < 0)
   {
    printf("Errore apertura FIFO\r\n");
    return 0;
   }
 // inizializzazione MD5
 MD5Init(&context);
 // estrazione dalla pipe dei dati a blocchi di 16 byte
 // e aggiornamento MD5
 while ((n = read(fifo, buffer, 16)) > 0)
      MD5Update(&context, buffer, n);
 close(fifo); // chiusura FIFO
 // visualizzazione in esadecimale del fingerprint
 MD5Final(fingerprint, &context);

 for (i=0; i<16; i++)
    printf ("%02X", fingerprint[i]);
 printf("\r\n");
 return 1;
}

