
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>

int spawn(const char program[], char* arguments[])
{
 int pid;
 // clonazione del processo
 pid = fork ();
 if (pid < 0)
   return -1; // errore clonazione processo
 if (pid > 0)
   return 0; // codice di successo restituito al processo padre
 execv(program, arguments);
 abort(); // errore esecuzione programma
}


int main (int argc, char* argv[])
{
 FILE *file;
 unsigned char buffer[16];
 int n;
 int fifo;

 if (argc != 2)
   {
    printf("Uso: %s file\r\n",argv[0]);
    return 0;
   }
 // creazione processo consumatore
 if (spawn("./consumer", NULL) < 0)
   {
    printf("Errore creazione processo\r\n");
    return 0;
   }
 // apertura in scrittura FIFO
 // (attesa connessione processo consumatore)
 fifo = open("./my_fifo", O_WRONLY);
 if (fifo < 0)
   {
    printf("Errore apertura FIFO\r\n");
    return 0;
   }
 // apertura in scrittura file
 file = fopen(argv[1], "rb");
 if (file == NULL)
   {
    printf("Errore apertura file \"%s\"\r\n",argv[1]);
    close(fifo); // chiusura FIFO
    return 0;
   }
 // lettura da file di blocchi di dati di 16 byte
 // e inserimento nella pipe
 while ((n = fread(buffer, 1, 16, file)) > 0)
      write(fifo, buffer, n);
 fclose(file); // chiusura file
 close(fifo); // chiusura FIFO
 usleep(1000000L); // 1s
 return 1;
}
