
#include "semaphore.h"

int semaphore_init(unsigned short value)
{
 int semaphore_id;
 int init_val;
 
 semaphore_id = semget(IPC_PRIVATE, 1, 0600 | IPC_CREAT | IPC_EXCL);
 if (semaphore_id == -1)
   return -1;
 init_val = value;
 if (semctl(semaphore_id, 0, SETVAL, init_val) == -1)
   return -1;
 return semaphore_id;
}

void semaphore_remove(int semaphore_id)
{
 semctl(semaphore_id, 0, IPC_RMID);
 return;
}

int semaphore_wait(int semaphore_id)
{
 struct sembuf op[1];
 op[0].sem_num = 0;
 op[0].sem_op = -1;
 op[0].sem_flg = 0;
 if (semop(semaphore_id, op, 1) == -1)
   return -1;
 return 0;
}

int semaphore_signal(int semaphore_id)
{
 struct sembuf op[1];
 op[0].sem_num = 0;
 op[0].sem_op = +1;
 op[0].sem_flg = 0;
 if (semop(semaphore_id, op, 1) == -1)
   return -1;
 return 0;
}

