
// posizioni dei campi nella stringa in formato NMEA $GPRMC
#define TIME_POS	       7
#define VALIDITY_POS	   14
#define LAT_POS		       16
#define LAT_SIGN_POS       26
#define LONG_POS	       28
#define LONG_SIGN_POS	   39
#define SPEED_POS          41

struct GPS_DATA
{
 // timestamp
 unsigned short hour;
 unsigned short minute;
 unsigned short second;
 unsigned short day;
 unsigned short month;
 unsigned short year;
 // posizione geografica
 char lat_sign; // N/S
 unsigned short lat_degree;
 unsigned short lat_minute;
 unsigned short lat_second;
 char long_sign; // E/W
 unsigned short long_degree;
 unsigned short long_minute;
 unsigned short long_second;
};

// connessione del dispositivo GPS
// specificando il numero di porta seriale
void GPS_open(unsigned char serial_port);

// disconnessione del dispositivo GPS
void GPS_close(void);

// funzione da invocare ripetutamente
// restituisce il valore 1 se il parametro gps_data contiene dati
// aggiornati validi, 0 altrimenti
int GPS_get(struct GPS_DATA* gps_data);
